unit UDemoNativeLayer;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ECMaps, ExtCtrls, StdCtrls, ComCtrls, Spin,UECMapUtil, OleCtrls, SHDocVw,
  UECMapAdressEdit, uecNativeMapControl,uecnativeshape,uecNativePanoramio,
  uecGeoLocalise;

type
  TFNativeLayer = class(TForm)
    Panel1: TPanel;
    PageControl1: TPageControl;
    TabPano: TTabSheet;
    TabKml: TTabSheet;
    Panel3: TPanel;
    web: TWebBrowser;
    ckbike: TCheckBox;
    map: TECNativeMap;
    address: TECAdressEdit;
    FrenchDep: TComboBox;
    Label1: TLabel;
    copyright: TLabel;
    Selected: TGroupBox;
    hideDep: TCheckBox;
    PolyColor: TPanel;
    Label2: TLabel;
    ColorDialog: TColorDialog;
    Label3: TLabel;
    HoverColor: TPanel;
    Transparence: TTrackBar;
    Label4: TLabel;
    Label5: TLabel;
    BorderColor: TPanel;
    area: TLabel;
    traffic: TCheckBox;
    geolocalise: TECGeoLocalise;
    Label6: TLabel;
    style: TComboBox;


    procedure PageControl1Change(Sender: TObject);
   

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure mapPanoramioClick(sender: TObject; const Item: TECShape;
      const ownerId, ownerName, PhotoId, PhotoDate, PhotoTitle, PhotoUrl,
      copyright: string);
    procedure ckbikeClick(Sender: TObject);
    procedure AdresseAdress(sender: TObject; const Latitude, Longitude: Double);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FrenchDepClick(Sender: TObject);
    procedure hideDepClick(Sender: TObject);
    procedure mapLoad(sender: TObject; const GroupName: string;
      const FinishLoading: Boolean);
    procedure mapShapeClick(sender: TObject; const item: TECShape);
    procedure PolyColorClick(Sender: TObject);
    procedure TransparenceChange(Sender: TObject);
    procedure trafficClick(Sender: TObject);
    procedure styleClick(Sender: TObject);
  private
    { Dclarations prives }
    idAreaPanoramio, idInfoPanoramio:integer;
    KmlPath : string;
  public
    { Dclarations publiques }
  end;

var
  FNativeLayer: TFNativeLayer;

implementation

{$R *.DFM}





{*
  event PanoramioLayerClick

  fired when click on image panoramio if map.PanoramioView.clickable = true
}
procedure TFNativeLayer.mapLoad(sender: TObject; const GroupName: string;
  const FinishLoading: Boolean);
begin

   selected.visible :=  (map.Group[GroupName].Polygones.Count>0) ;
   HideDep.checked  := not map.Group[GroupName].visible;

  if map.Group[GroupName].Polygones.Count>0 then
  begin
    map.Group[GroupName].polygones[0].hint := GroupName;
    Transparence.Position := map.Group[GroupName].Polygones[0].Opacity;
    Polycolor.color       := map.group[GroupName].Polygones[0].Fillcolor;
    HoverColor.Color      := map.group[GroupName].Polygones[0].HoverColor;
    Bordercolor.color     := map.group[GroupName].Polygones[0].Color;
    Area.Caption          := DoubleToStr(map.Group[GroupName].Polygones[0].area)+' Km';
  end;

end;

procedure TFNativeLayer.mapPanoramioClick(sender: TObject; const Item: TECShape;
  const ownerId, ownerName, PhotoId, PhotoDate, PhotoTitle, PhotoUrl,
  copyright: string);
var s:string;
begin


 s := '<img src="'+map.Panoramio.PhotoSize(map.Panoramio.ClickIndex,pimSmall)+'" width=240 height=180><br><h3>'+PhotoTitle+'</h3>';

 map.shapes.InfoWindows[0].content := s;
 map.shapes.InfoWindows[0].SetPosition(item.Latitude,item.Longitude);
 map.shapes.InfoWindows[0].Visible := true;

 s :=
 '<h3>'+PhotoTitle+'</h3>'+
  '<div><img src="'+PhotoUrl+'" class="pano"><div>'+
  '<h4>Author: '+ownerName+'</h4>'+
  copyright;

  WebBrowserLoadHTML(web,'<html><body>'+
                         '<style type="text/css">.pano {'+
                     //    'height:100%;'+
                         'width:100%}</style>'+s+'</body></html>');
end;





procedure TFNativeLayer.mapShapeClick(sender: TObject; const item: TECShape);
var poly:TECShapePolygone;
begin
   if item is TECShapePolygone then
   begin
     poly := TECShapePolygone(item);

     FrenchDep.itemIndex := FrenchDep.items.indexof(poly.Group.name);
     FrenchDepClick(nil);
   end;
end;

procedure TFNativeLayer.PageControl1Change(Sender: TObject);
var FusionStyle:string;
begin

 map.PanoramioLayer := PageControl1.ActivePage = tabPano;



end;

procedure TFNativeLayer.PolyColorClick(Sender: TObject);
begin
 if ColorDialog.execute then
 begin
   (Sender as TPanel).color := ColorDialog.Color;

   case (Sender as TPanel).tag of

    0 : map.group[Selected.caption].Polygones[0].Fillcolor  := ColorDialog.Color;
    1 : map.group[Selected.caption].Polygones[0].HoverColor := ColorDialog.Color;
    2 : map.group[Selected.caption].Polygones[0].Color      := ColorDialog.Color;

   end;
 end;

end;

procedure TFNativeLayer.styleClick(Sender: TObject);
begin
if style.itemindex>-1 then

 map.group[Selected.caption].Polygones[0].style := TBrushStyle(style.itemindex);
end;

procedure TFNativeLayer.trafficClick(Sender: TObject);
begin
 map.TrafficLayer := traffic.checked;
end;

procedure TFNativeLayer.TransparenceChange(Sender: TObject);
begin
  map.group[Selected.caption].Polygones[0].Opacity := Transparence.Position;
end;

procedure TFNativeLayer.AdresseAdress(sender: TObject; const Latitude,
  Longitude: Double);
begin
 map.setCenter(LAtitude,Longitude);
end;

procedure TFNativeLayer.ckbikeClick(Sender: TObject);
begin
  if  ckBike.checked then
  map.TileServer := tsOpenCycleMap
 else
 begin
   map.tileServer := tsOSM;
 end;
end;

procedure TFNativeLayer.FormActivate(Sender: TObject);
begin
// map.PanoramioLayer := PageControl1.ActivePage = tabPano;
end;

procedure TFNativeLayer.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 action := caFree;
end;

procedure TFNativeLayer.FormCreate(Sender: TObject);
var i:integer;
    s:string;
begin

   FrenchDep.items.BeginUpdate;


  for I := 1 to 9 do
  begin
   FrenchDep.items.add('0'+inttostr(i));
  end;

  for I := 10 to 95 do
  begin
   FrenchDep.items.add(inttostr(i));
  end;

  FrenchDep.items.EndUpdate;

  KmlPath := extractfilepath(application.exename)+'kml\';

  map.shapes.InfoWindows.add(0,0,'');
  map.shapes.InfoWindows[0].width :=  250;
  map.shapes.InfoWindows[0].YAnchor := -16;
  map.shapes.InfoWindows[0].ZIndex  := 10;

  map.PanoramioLayer := PageControl1.ActivePage = tabPano;

  Map.LocalCache     := ExtractFilePath(application.exename) + 'cache';

end;

procedure TFNativeLayer.FrenchDepClick(Sender: TObject);
var s:string;
begin

   if FrenchDep.ItemIndex=-1 then exit;

   s :=FrenchDep.items.Strings[FrenchDep.ItemIndex];

   if map.Group[s].Polygones.Count = 0 then
   begin
      map.Group[s].LoadFromFile(kmlPath+s+'.kml') ;
    end else begin
               Transparence.OnChange := nil;
               Transparence.Position := map.Group[s].Polygones[0].Opacity;
               Transparence.OnChange := TransparenceChange;
               Polycolor.color       := map.group[s].Polygones[0].fillcolor;
               HoverColor.Color      := map.group[s].Polygones[0].HoverColor;
               Bordercolor.color     := map.group[s].Polygones[0].color;
               style.itemindex       := integer(map.group[s].Polygones[0].style);
               Area.Caption := DoubleToStrDigit(map.Group[s].Polygones[0].area,4)+' Km';
             end;

      map.Group[s].visible := true;

   selected.visible :=  (map.Group[s].Polygones.Count>0) ;
   HideDep.checked  := not map.Group[s].visible;
   selected.Caption := s;


end;

procedure TFNativeLayer.hideDepClick(Sender: TObject);
var s:string;
begin

 if FrenchDep.ItemIndex=-1 then exit;

   s :=FrenchDep.items.Strings[FrenchDep.ItemIndex];

   map.Group[s].visible := not HideDep.checked;

end;

end.
