unit UMainNativePOI;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, uecGraphics,
  Dialogs, ExtCtrls, ECMaps, ComCtrls, StdCtrls,uecmaputil, uecNativeMapControl,uecNativeShape;

type
  TFormNativePoi = class(TForm)
    Panel1: TPanel;
    AddPois: TButton;
    PoiNumber: TPanel;
    infos: TPanel;
    fitbounds: TButton;
    map: TECNativeMap;
    procedure AddPoisClick(Sender: TObject);
    procedure mapOverlayClick(sender: TObject; const Index: Integer;
      const dLatitude, dLongitude: Double; const OverlayType: TOverlayType);
    procedure mapOverlayMove(sender: TObject; const Index: Integer;
      const dLatitude, dLongitude: Double; const OverlayType: TOverlayType);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure fitboundsClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure mapMapClick(sender: TObject; const Lat, Lng: Double);
    procedure mapShapeClick(sender: TObject; const item: TECShape);
    procedure mapShapeMove(sender: TObject; const item: TECShape;
      var cancel: Boolean);
  private
    { Dclarations prives }
    procedure UpdatePoiNumber;
    procedure doOwnerDrawPOI(const canvas:TECCanvas;var Rect:TRect;item:TECShape) ;
    procedure doNumDrawPOI(const canvas:TECCanvas;var r:TRect;item:TECShape) ;
  public
    { Dclarations publiques }
  end;

var
  FormNativePoi: TFormNativePoi;

implementation

{$R *.dfm}

procedure TFormNativePoi.AddPoisClick(Sender: TObject);
var x,y,i,sx,sy:integer;
begin


 map.BeginUpdate;

 for y := 0 to 99 do
  begin
   for x  := 0 to 9 do
   begin

     if x<5 then
      sx := 1
     else
     sx := -1;

     if y<5 then
      sy := 1
     else
     sy := -1;

     i := map.shapes.pois.add(map.Latitude+(sx*(x*0.004)),map.Longitude+(sy*(y*0.004)));


       map.shapes.pois[i].POIUnit := puPixel;

       map.shapes.pois[i].width := 32;
       map.shapes.pois[i].height:= 32;


       map.shapes.pois[i].hint := 'Poi n'+inttostr(i);

       map.shapes.pois[i].Draggable := true;

       map.shapes.pois[i].Color := RGB(random(255),random(255),random(255))   ;

       case random(5) of
        0 : map.shapes.pois[i].POIShape := poiEllipse;
        1 : map.shapes.pois[i].POIShape := poiStar;
        2 : map.shapes.pois[i].POIShape := poiRect;
        3 : map.shapes.pois[i].POIShape := poiTriangle;
        4 : map.shapes.pois[i].POIShape := poiOwnerDraw;
       end;


       if (map.shapes.pois[i].POIShape<>poiTriangle) and (map.shapes.pois[i].POIShape<>poiStar) then

       map.shapes.pois[i].OnAfterDraw := doNumDrawPOI;


   end;
  end;

  UpdatePoiNumber;

  map.EndUpdate;
end;


procedure TFormNativePoi.UpdatePoiNumber;
begin
  PoiNumber.caption := 'Total Pois : '+inttostr(map.shapes.pois.count);
end;

procedure TFormNativePoi.mapMapClick(sender: TObject; const Lat, Lng: Double);
begin

end;

// event Click on POI
procedure TFormNativePoi.mapOverlayClick(sender: TObject; const Index: Integer;
  const dLatitude, dLongitude: Double; const OverlayType: TOverlayType);
begin

 if OverlayType<>ovPoi then exit;

 Infos.caption := 'Click Poi n '+inttostr(index);
end;

// event Move POI
procedure TFormNativePoi.mapOverlayMove(sender: TObject; const Index: Integer;
  const dLatitude, dLongitude: Double; const OverlayType: TOverlayType);
begin

 if overlayType = ovPoi then
 begin

 end;

end;


procedure TFormNativePoi.mapShapeClick(sender: TObject; const item: TECShape);
begin
 Infos.caption := 'Click Poi n '+inttostr(item.IndexOf);
end;

procedure TFormNativePoi.mapShapeMove(sender: TObject; const item: TECShape;
  var cancel: Boolean);
begin
 Infos.caption := 'Move Poi n '+inttostr(item.indexof);
end;

// draw number on shape
procedure TFormNativePoi.doNumDrawPOI(const canvas:TECCanvas;var r:TRect;item:TECShape) ;
var x,y,w,h : integer;
   s : string;
begin

    canvas.font.style := [fsBold];

    s := inttostr(item.Id);


    w := canvas.TextWidth(s) ;
    h:= canvas.TextHeight(s) ;


    x := 1+((r.Left + r.Right) - w) DIV 2   ;
    y := 1+((r.Top + r.Bottom) - h) DIV 2 ;

    canvas.brush.Style := bsClear;

    canvas.font.color := clWhite;

   canvas.TextRect(r,x,y,s);
end;

// owner draw poi, here transparancy text
procedure TFormNativePoi.doOwnerDrawPOI(const canvas:TECCanvas;var Rect:TRect;item:TECshape) ;
begin

  canvas.brush.Style := bsClear;

  if item.Hover then
     canvas.font.color := item.HoverColor
    else
     canvas.font.color := item.color;


  canvas.font.Style := [fsBold];

  item.Width  := canvas.TextWidth(item.hint) ;
  item.height := canvas.TextHeight(item.hint) ;

  item.x := item.x - (item.Width  div 2);
  item.y := item.y - (item.height  div 2);




  canvas.TextOut(item.x,item.y,item.hint);

end;

procedure TFormNativePoi.fitboundsClick(Sender: TObject);
begin
 map.shapes.pois.getBounds;
 map.fitbounds(map.shapes.pois.NorthEastLatitude,map.shapes.pois.NorthEastLongitude,
                     map.shapes.pois.SouthWestLatitude,map.shapes.pois.SouthWestLongitude);
end;

procedure TFormNativePoi.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 action := caFree;
end;

procedure TFormNativePoi.FormCreate(Sender: TObject);
begin
 map.MinZoom := 4;

 map.LocalCache := extractfilepath(application.exename)+'cache';
 // set procedure for draw poiOwnerDraw
 map.shapes.pois.OnOwnerDraw := doOwnerDrawPOI;

 AddPoisClick(nil);
end;

end.
