unit UMainNativeRoute;

{$I Delphi_Versions.inc}

interface



uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, Buttons, ExtCtrls, OleCtrls,
  ComCtrls, TeeProcs, TeEngine, Chart,Series, ShDocVw, MSHTML, uecNativeMapControl,
  uecGeoLocalise,activex,uecNativeshape, UECMapUtil;

type
  TFDemoNativeRoute = class(TForm)
    PanelStartEnd: TPanel;
    cbStart: TComboBox;
    lbstart: TLabel;
    Label1: TLabel;
    cbDestination: TComboBox;
    Panel2: TPanel;
    RouteAdd: TButton;
    Colordialog: TColorDialog;
    Panel1: TPanel;
    routes: TComboBox;
    pcInfo: TPageControl;
    TabTrip: TTabSheet;
    Panel3: TPanel;
    Panel13: TPanel;
    WebBrowser: TWebBrowser;
    Splitter1: TSplitter;
    TabProfil: TTabSheet;
    Chart: TChart;
    pnCalculAltitude: TPanel;
    progressAltitude: TProgressBar;
    Label2: TLabel;
    Panel4: TPanel;
    NextPageElevation: TSpeedButton;
    Panel5: TPanel;
    PrevPageElevation: TSpeedButton;
    Panel6: TPanel;
    btAbortAlt: TButton;
    map: TECNativeMap;
    rbDriving: TRadioButton;
    rbBicycle: TRadioButton;
    rbWalking: TRadioButton;
    RouteEValue: TSpinEdit;
    RouteColor: TPanel;
  

    procedure RouteAddClick(Sender: TObject);

    procedure routesChange(Sender: TObject);

    procedure RouteColorClick(Sender: TObject);


    procedure cbStartChange(Sender: TObject);


    procedure pcInfoChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Panel5Resize(Sender: TObject);
    procedure Panel4Resize(Sender: TObject);
    procedure NextPageElevationClick(Sender: TObject);
    procedure PrevPageElevationClick(Sender: TObject);
    procedure ChartClickSeries(Sender: TCustomChart; Series: TChartSeries;
      ValueIndex: Integer; Button: TMouseButton; Shift: TShiftState; X,
      Y: Integer);



    {$IFDEF D5_OR_HIGHER}
     procedure WebBrowserBeforeNavigate2(Sender: TObject;
       const pDisp: IDispatch; var URL, Flags, TargetFrameName, PostData,
      Headers: OleVariant; var Cancel: WordBool);
    {$ELSE}
       procedure WebBrowserBeforeNavigate2(Sender: TObject;
       pDisp: IDispatch; var URL, Flags, TargetFrameName, PostData,
      Headers: OleVariant; var Cancel: WordBool);
    {$ENDIF}



    procedure btAbortAltClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);

    procedure FormActivate(Sender: TObject);
   
    procedure RouteEValueChange(Sender: TObject);
    procedure mapRoutePath(sender: TObject; const params: string;
      routePath: TECRoutePath);


  private
    { Dclarations prives }


   idMarker : integer;



  procedure doShowDataRoute(const id:integer);
   procedure doUpdateDataRoute(const id:integer);
   procedure doUpdateElevation;
   procedure doShowAltitude(const Polyline:TECShapeline);
   procedure doOnGetAltitude(Sender:TECShapeLine;const Total:integer;var cancel:boolean);
  public
    { Dclarations publiques }
  end;

var
  FDemoNativeRoute: TFDemoNativeRoute;

implementation

{$R *.DFM}




const HTML_BODY_TEMPLATE = '<html><style type="text/css">'+
          'body{ background: #fff;color: #000000;overflow-x:hidden;'+
	               'margin : 0;'+
                 'border-style :none;'+
               '}'+
          'div {margin:0;padding:5px;width:100%;overflow-x:hidden}'+
          'div a {text-decoration:none;font: 12pt verdana;color: #111;'+
                 'margin : 0;'+
                 'display:block}'+
          '.km {color:#4FB2FF;font-size:x-small; text-align:right}'+
          '.odd{background: #eee;color: #000000;}'+

          '</style>'+

          '<body>';








{*
   event OnBeforeNavigate2

   fired when click on trip information list

   url = xxx#id_item_list_information

}


procedure TFDemoNativeRoute.WebBrowserBeforeNavigate2(Sender: TObject;
  {$IFDEF D5_OR_HIGHER}const{$ENDIF} pDisp: IDispatch; var URL, Flags, TargetFrameName, PostData,
  Headers: OleVariant; var Cancel: WordBool);
var i:integer;
    link:string;
begin

 { get only id }
 i := pos('#',url);

 if i<1 then exit;



 i := SecureStrToInt(copy(url,i+1,length(url)),-1);

 if i<0 then
   exit;

 cancel := true;

 if not assigned(map.shapes.lines[routes.ItemIndex]) then
   exit;


 map.shapes.markers[idMarker].setPosition(map.shapes.lines[routes.ItemIndex].Path[i].lat,
                                   map.shapes.lines[routes.ItemIndex].Path[i].lng);


 map.Panto(map.shapes.markers[idMarker].latitude,map.shapes.markers[idMarker].longitude);



end;




{*
   Add new route
}
procedure TFDemoNativeRoute.RouteAddClick(Sender: TObject);
var lat1,lng1,lat2,lng2 : double;
    title:string;
    RouteType : TMQRouteType;
begin




  if rbWalking.checked then
   routeType := rtPedestrian
  else
  if rbBicycle.checked then
   routeType := rtBicycle
  else
   routeType := rtFastest;



  RouteAdd.enabled := false;


   // When the route calculation is completed, the event RoutePath will be called
   map.GetAsyncRoutePathByAdress(cbStart.Text,cbDestination.text,routeType);

   Title := cbStart.text+' > '+cbDestination.text + ' > '+rtToStr(routeType);

   routes.itemindex := routes.items.add(Title);

end;

// in response at map.GetAsyncRoutePathByAdress
procedure TFDemoNativeRoute.mapRoutePath(sender: TObject; const params: string;
  routePath: TECRoutePath);
var Line : TECShapeLine;
begin

 // addRoute create a TECShapeLine
 line := map.addRoute(routePath);
  // roads are managed as part TECShapeLine
 Line.color     := RouteColor.Color;
 Line.weight    := RouteEValue.value;
 // show intermediate points
 Line.ShowText  := true;

 doShowDataRoute(line.indexof);

 routeAdd.enabled := true;
end;


{*
   select new route
}
procedure TFDemoNativeRoute.routesChange(Sender: TObject);
begin
 doShowDataRoute(routes.itemindex);

end;


{*
   update the screen with the properties of the selected route
}
procedure TFDemoNativeRoute.doShowDataRoute(const id:integer);
var i,j,wpcount:integer;
    s,html:string;
    
    odd:boolean;

    l:TStringList;
begin



 if id<0 then exit;


 s := routes.text;

 cbStart.text       := trim(strtoken(s,'>'));
 cbDestination.text := trim(strtoken(s,'>'));

 case StrToRT(trim(s)) of

  rtPedestrian : rbWalking.checked := true;

  rtFastest    : rbDriving.checked := true;

  rtBicycle    : rbBicycle.checked := true;
 end;



  routes.itemindex := id ;

  RouteColor.Color   := map.shapes.lines[id].color  ;
  RouteEValue.value  := map.shapes.lines[id].weight ;


  // instructions step by step
  html := HTML_BODY_TEMPLATE;
  odd  := false;
  j    := map.shapes.lines[id].count-1;

  for i:=0 to j do
  begin

    s := map.shapes.lines[id].Path[i].Text;

    // all steps have no instructions

    if s='' then continue;

    html := html+'<div id="step'+inttostr(i)+'"';

    if odd then html:=html+' class="odd"';

    odd := not odd;

    // distance is in meters, here in km

   html:=html+'><a href="#'+inttostr(i)+'">'+s+'<div class="km">'+format('%8.2f km',[map.shapes.lines[id].Path[i].distance/1000])+'</div></a>'+'</div>';
  end;

  html := html+'<div ';

   if odd then html:=html+' class="odd"';
   odd := not odd;

   html:=html+'>'+format('Distance : <b>%.2f km</b><br>Estimated time : <b>'+TimeToStr(map.shapes.lines[id].duration/24/3600),[map.shapes.lines[id].distance])+'</b></div>';


   html := html + '</body></html>';

   l := TStringList.create;
   l.text := html;
   l.savetofile(application.exename+'.htm');
   webbrowser.Navigate(application.exename+'.htm');

   // WebBrowserLoadHtml declared in UECMapUtil
  // WebBrowserLoadHtml(WebBrowser,html);





 // move marker at start route
 map.shapes.Markers[idMarker].setPosition(map.shapes.lines[id].path[0].Lat,map.shapes.lines[id].path[0].lng);

 map.panto( map.shapes.Markers[idMarker].latitude,map.shapes.Markers[idMarker].Longitude);


 pcInfoChange(nil);

end;





{*
  update properties without recalculating the route
}
procedure TFDemoNativeRoute.doUpdateDataRoute(const id:integer);
begin
 if id<0 then exit;

  map.shapes.lines[id].color     := RouteColor.Color;

  map.shapes.lines[id].weight    := RouteEValue.value;

end;






{*
   select color
}
procedure TFDemoNativeRoute.RouteColorClick(Sender: TObject);
begin
 if ColorDialog.execute then
 begin
    (Sender as TPanel).color := ColorDialog.color;
    if (routes.ItemIndex>-1) then
     map.shapes.lines[routes.ItemIndex].color     := RouteColor.Color

 end;
end;



procedure TFDemoNativeRoute.RouteEValueChange(Sender: TObject);
begin
 if (routes.ItemIndex>-1) then
     map.shapes.lines[routes.ItemIndex].Weight     := RouteEValue.value;
end;





procedure TFDemoNativeRoute.cbStartChange(Sender: TObject);
begin
 RouteAdd.enabled := (cbStart.text<>'') and (cbDestination.text<>'');
end;











{*
   event fired by getAltitudes

   @param Sender TECShapeLine
   @param Total number of altitude's point calculated
   @cancel flag for abort calcul
}
procedure TFDemoNativeRoute.doOnGetAltitude(Sender: TECShapeLine;const Total:integer;var cancel:boolean);
begin
  ProgressAltitude.Position := total;
  cancel                    := btAbortAlt.tag = -1;

  // tag = 0 for recalculate altitude
  if cancel then sender.tag := 0;

end;

procedure TFDemoNativeRoute.pcInfoChange(Sender: TObject);
begin
  doUpdateElevation;
end;

procedure TFDemoNativeRoute.doUpdateElevation;
var Polyline : TECShapeline;

begin
 if pcInfo.ActivePage <> TabProfil then exit;


 if not assigned(map.shapes.lines[routes.itemindex]) then exit;

 Application.ProcessMessages;

 Polyline := nil;


   Polyline := map.shapes.lines[routes.itemindex];

   if assigned(Polyline) and (Polyline.tag=0) then
   begin



     ProgressAltitude.min := 0;
     ProgressAltitude.max := Polyline.Count;
     ProgressAltitude.Position := 0;

     btAbortAlt.tag := 0;

     pnCalculAltitude.visible := true;

     Application.ProcessMessages;

     Polyline.tag:=1;

     Polyline.getAltitudes(doOnGetAltitude);

     pnCalculAltitude.Visible := false;

 end;

 doShowAltitude(Polyline);



 Application.ProcessMessages;

end;


procedure TFDemoNativeRoute.doShowAltitude(const Polyline:TECShapeline);
var i : integer;
    Altitude,Km: double;
begin

  if not assigned(Polyline) then
    exit;

  chart.Series[0].clear;
  chart.title.text[0]:='';
  chart.BottomAxis.Automatic := true;

 Chart.Series[0].addXY(Km,Polyline.Path[0].Alt,'',Polyline.Color);
 km := 0;

 for i:=1 to Polyline.Count-1 do
 begin
  Km := km + DistanceFrom(Polyline.Path[i-1].Latitude,Polyline.Path[i-1].Longitude,
                         Polyline.Path[i].Latitude,Polyline.Path[i].Longitude);

  altitude := Polyline.Path[i].Alt;

  if Altitude<0 then
   Altitude := 0;

  Chart.Series[0].addXY(Km,altitude,'',Polyline.Color);
   
 end;
end;


procedure TFDemoNativeRoute.FormActivate(Sender: TObject);
begin
  show;
end;

procedure TFDemoNativeRoute.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 action := caFree;
end;

procedure TFDemoNativeRoute.FormCreate(Sender: TObject);
begin

 cbStart.Tag       := -1;
 cbDestination.Tag := -1;

  with Chart do
  begin
   AddSeries(TAreaSeries.Create(Chart));
   title.text.clear;
   chart.title.text.Add('');
   Legend.Visible     := false;
  end;

  map.LocalCache := extractfilepath(application.exename)+'cache';

  { new marker }
   idMarker := map.shapes.markers.add(map.LAtitude,map.Longitude);
  { load new icon }
  map.shapes.markers[idMarker].filename := 'http://google-maps-icons.googlecode.com/files/car.png';

  map.shapes.markers[idMarker].zindex := 1; // for show over the line

  pcInfo.ActivePage := TabTrip;

  //map.TileServer := tsYandexNormal;

end;



procedure TFDemoNativeRoute.Panel5Resize(Sender: TObject);
begin
 PrevPageElevation.top := (Panel5.height div 2) - 20;
end;

procedure TFDemoNativeRoute.Panel4Resize(Sender: TObject);
begin
 NextPageElevation.top := (Panel4.height div 2) - 20;
end;

procedure TFDemoNativeRoute.NextPageElevationClick(Sender: TObject);
begin
 chart.Nextpage ;
end;

procedure TFDemoNativeRoute.PrevPageElevationClick(Sender: TObject);
begin
 Chart.PreviousPage;
end;

procedure TFDemoNativeRoute.ChartClickSeries(Sender: TCustomChart;
  Series: TChartSeries; ValueIndex: Integer; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);

var Polyline : TECShapeline;
begin

 if not assigned(map.shapes.lines[routes.itemindex]) then
  exit;

 Polyline := map.shapes.lines[routes.itemindex];

 if not assigned(Polyline) then exit;

 map.shapes.markers[idMarker].setPosition(Polyline.Path[ValueIndex].latitude,
                                   Polyline.Path[ValueIndex].longitude);

 map.Panto(map.shapes.markers[idMarker].latitude,map.shapes.markers[idMarker].longitude);


 chart.title.text[0]:=map.address;
 chart.refresh;
end;



procedure TFDemoNativeRoute.btAbortAltClick(Sender: TObject);
begin
 btAbortAlt.tag := -1;
end;


end.
